/**
 * @Date: 2020/11/23 7:55 下午
 * @Author: Fioanna
 * @Description: 日期选择器
 */
import dateRangeProps from './types';
import ADataPicker from 'ant-design-vue/es/date-picker/index';
var ARangePicker = ADataPicker.RangePicker;
export default {
  name: 'EDateRange',
  props: dateRangeProps,
  computed: {
    rangeDates: function rangeDates() {
      return [this.startValue, this.endValue];
    }
  },
  methods: {
    _change: function _change(dates) {
      // 按照valueFormat的格式输出时间列表
      this.$emit('change', dates);
    }
  },
  render: function render() {
    var h = arguments[0];
    var _this$$props = this.$props,
        disabled = _this$$props.disabled,
        showTime = _this$$props.showTime,
        showFormat = _this$$props.showFormat,
        valueFormat = _this$$props.valueFormat,
        disabledDate = _this$$props.disabledDate; // placeholder={['开始时间', '结束时间']}

    return h(ARangePicker, {
      attrs: {
        disabled: disabled,
        showTime: showTime,
        format: showFormat,
        valueFormat: valueFormat,
        disabledDate: disabledDate,
        value: this.rangeDates
      },
      on: {
        "change": this._change
      }
    });
  }
};