/**
 * @Date: 2020/11/23 6:48 下午
 * @Author: Fioanna
 * @Description: 多选下拉选择器，继承自ESelect
 */
import Select from '../Select';
export default {
  name: 'EMultipleSelect',
  "extends": Select,
  data: function data() {
    return {
      // 下拉框模式
      mode: 'multiple'
    };
  },
  methods: {
    // 下拉值改变
    _change: function _change(value) {
      var _this = this;

      var optionList = [];
      value.forEach(function (val) {
        var target = _this.optionList.find(function (item) {
          return item[_this.valueName] === val;
        });

        if (target) {
          optionList.push(target);
        }
      });
      var labelList = optionList.map(function (item) {
        return item[_this.labelName];
      });
      this.$emit('change', value, labelList, optionList);
    },
    // 是否存在默认选中值
    _judgeExistValue: function _judgeExistValue(options) {
      var _this2 = this;

      if (this.value) {
        // 多选的默认值列表，过滤options中存在的value
        var optionList = [];
        var isExist = true;
        this.value.forEach(function (val) {
          var target = options.find(function (item) {
            return item[_this2.valueName] === val;
          });

          if (target) {
            optionList.push(target);
          } else {
            isExist = false;
          }
        });

        if (!isExist) {
          // 如果可选列表中不存在默认值，则清空默认选中
          var valueList = optionList.map(function (item) {
            return item[_this2.valueName];
          });
          var labelList = optionList.map(function (item) {
            return item[_this2.labelName];
          });
          this.$emit('change', valueList, labelList, optionList);
        }
      }
    }
  }
};