"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _babelHelperVueJsxMergeProps = _interopRequireDefault(require("babel-helper-vue-jsx-merge-props"));

var _table = _interopRequireDefault(require("ant-design-vue/es/table"));

var _button = _interopRequireDefault(require("ant-design-vue/es/button"));

var _Table = require("../Table");

var _types = _interopRequireDefault(require("./types"));

require("./style.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? Object(arguments[i]) : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// 获取数据页面类型：1 上一页，2 下一页
var PAGE_TYPE = {
  LAST: 1,
  NEXT: 2
};
var _default = {
  name: 'EBigTable',
  props: _types["default"],
  data: function data() {
    return {
      tableLoading: false,
      // 表格的loading
      tableDataSource: [],
      // 表格当前页的数据
      isFirstPage: true,
      // 是否是第一页
      isLastPage: true,
      // 是否是最后一页
      pageType: PAGE_TYPE.NEXT,
      // 默认下一页
      pageIndex: 1,
      // 当前页码
      pageDataId: undefined // 后台用来获取上一页下一页的id

    };
  },
  computed: {
    refId: function refId() {
      return this.$props.idKey || this.$props.rowKey;
    },
    // 展示用的当前页码
    showPageIndex: function showPageIndex() {
      return this.$data.pageIndex > 1 ? this.$data.pageIndex - 1 : 1;
    }
  },
  render: function render() {
    var _this = this;

    var h = arguments[0];
    var _this$$data = this.$data,
        tableLoading = _this$$data.tableLoading,
        tableDataSource = _this$$data.tableDataSource;

    var props = _objectSpread({}, this.$props, {
      loading: tableLoading,
      dataSource: tableDataSource,
      pagination: false // 是否展示分页器

    });

    var table = h(_table["default"], (0, _babelHelperVueJsxMergeProps["default"])([{
      "class": "big-table"
    }, {
      props: props,
      scopedSlots: _objectSpread({}, this.$scopedSlots)
    }, {
      on: {
        "change": this._loadData,
        "expand": function expand(expanded, record) {
          _this.$emit('expand', expanded, record);
        }
      }
    }]), [Object.keys(this.$slots).map(function (name) {
      return h("template", {
        slot: name
      }, [_this.$slots[name]]);
    }), this.$props.showPager ? h("div", {
      slot: "footer",
      "class": "pager"
    }, [h("span", ["\u5F53\u524D\u7B2C", this.$data.pageIndex, "\u9875"]), h(_button["default"], {
      attrs: {
        type: "primary",
        ghost: true,
        disabled: this.isFirstPage
      },
      on: {
        "click": this._firstPage
      }
    }, ["\u56DE\u5230\u9996\u9875"]), h(_button["default"], {
      attrs: {
        type: "primary",
        ghost: true,
        disabled: this.isFirstPage
      },
      on: {
        "click": this._lastPage
      }
    }, ["\u4E0A\u4E00\u9875"]), h(_button["default"], {
      attrs: {
        type: "primary",
        ghost: true,
        disabled: this.isLastPage
      },
      on: {
        "click": this._nextPage
      }
    }, ["\u4E0B\u4E00\u9875"])]) : null]);
    return h("div", {
      "class": "table-wrapper"
    }, [table]);
  },
  created: function created() {
    if (this.$props.autoLoad) {
      this._firstPage();
    }
  },
  methods: {
    /**
     * 获取当前页表格数据
     * @param pagination
     * @param filters
     * @param sorter
     * @returns {Promise<void>}
     * @private
     */
    _loadData: function () {
      var _loadData2 = _asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee(pagination, filters, sorter) {
        var parameter, result, list;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                // 请求数据时table展示loading
                this.$data.tableLoading = true;
                parameter = _objectSpread({
                  pageType: this.$data.pageType,
                  pageIndex: pagination && pagination.current ? pagination.current : this.$data.pageIndex,
                  pageSize: this.$props.pageSize
                }, filters); // if (sorter && sorter.field) {
                //   parameter.sortField = sorter.field
                // }
                // if (sorter && sorter.order) {
                //   parameter.sortOrder = sorter.order
                // }

                if (sorter && sorter.field && sorter.order && !isNaN(Number(sorter.field))) {
                  parameter.orderByKeys = [{
                    fieldNo: Number(sorter.field),
                    index: 0,
                    sortType: sorter.order === 'ascend' ? _Table.SORT_TYPE.ASCENDING : _Table.SORT_TYPE.DESCENDING
                  }];
                }

                if (this.$data.pageDataId) {
                  parameter.refId = this.$data.pageDataId;
                }

                _context.prev = 4;
                _context.next = 7;
                return this.data(parameter);

              case 7:
                result = _context.sent;
                list = result.list;
                this.$data.tableDataSource = list; // 根据协议判断是否是第一页和最后一页

                this.$data.isFirstPage = result.isFirstPage === 1;

                if (this.$data.isFirstPage) {
                  this.$data.pageIndex = 1;
                }

                this.$data.isLastPage = result.isLastPage === 1;
                this.$data.tableLoading = false;
                _context.next = 20;
                break;

              case 16:
                _context.prev = 16;
                _context.t0 = _context["catch"](4);
                this.$data.tableLoading = false;
                throw _context.t0;

              case 20:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[4, 16]]);
      }));

      function _loadData(_x, _x2, _x3) {
        return _loadData2.apply(this, arguments);
      }

      return _loadData;
    }(),

    /**
     * 获取上一页数据
     * @private
     */
    _lastPage: function _lastPage() {
      var _this2 = this;

      // 如果正在请求数据则return
      if (this.$data.tableLoading) return;
      this.$data.pageType = PAGE_TYPE.LAST; // 大数据列表是无count总数的，所以需要下一页数据需要通过lastId来判断，lastId不传则是第一页

      if (this.$data.tableDataSource.length > 0) {
        this.$data.pageDataId = this.$data.tableDataSource[0][this.refId];
      } // this._minusPageIndex()


      this._loadData({
        current: this.$data.pageIndex - 1
      }).then(function () {
        _this2._minusPageIndex();
      })["catch"](function () {// 上一页协议获取失败，页码需要加回去
        // this.pageIndex++
      });
    },

    /**
     * 返回第一页
     * @private
     */
    _firstPage: function _firstPage() {
      this.refresh(true);
    },

    /**
     * 获取下一页数据
     * @private
     */
    _nextPage: function _nextPage() {
      var _this3 = this;

      // 如果正在请求数据则return
      if (this.$data.tableLoading) return;
      this.$data.pageType = PAGE_TYPE.NEXT; // 大数据列表是无count总数的，所以需要下一页数据需要通过lastId来判断，lastId不传则是第一页

      var dataLength = this.$data.tableDataSource.length;

      if (dataLength > 0) {
        this.$data.pageDataId = this.$data.tableDataSource[dataLength - 1][this.refId];
      } // this.$data.pageIndex++


      this._loadData({
        current: this.$data.pageIndex + 1
      }).then(function () {
        _this3.$data.pageIndex++;
      })["catch"](function () {// 下一页协议获取失败，页码需要减回去
        // this._minusPageIndex()
      });
    },
    // 减去页码
    _minusPageIndex: function _minusPageIndex() {
      // 当当前页码大于1,才能减
      if (this.$data.pageIndex > 1) this.$data.pageIndex--;
    },

    /**
     * 表格重新加载方法
     * 如果参数为 true, 则强制刷新到第一页
     * @param Boolean bool
     */
    refresh: function refresh() {
      var bool = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      if (bool) {
        this.$data.pageIndex = 1;
        this.$data.pageType = PAGE_TYPE.NEXT;
        this.$data.pageDataId = undefined;
      }

      this._loadData().then(function () {})["catch"](function () {});
    }
  }
};
exports["default"] = _default;