"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EASY_DETAIL_TYPE = exports.DetailProps = void 0;

var _vueTypes = _interopRequireDefault(require("ant-design-vue/es/_util/vue-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var DetailProps = {
  // 卡片标题
  cardTitle: _vueTypes["default"].string,
  // 数据展示列数
  column: _vueTypes["default"].oneOfType([_vueTypes["default"].number.def(3), _vueTypes["default"].object]).def(3),
  // column: PropTypes.number.def(3),
  // 文字数据标题
  infoTitle: _vueTypes["default"].string,
  // 文字数据列表
  infoList: _vueTypes["default"].oneOfType([_vueTypes["default"].array, _vueTypes["default"].shape({
    // 标题
    title: _vueTypes["default"].string,
    // key
    key: _vueTypes["default"].string
  })]),
  // 图文数据标题
  imgTitle: _vueTypes["default"].string,
  // 图文数据列表
  imgList: _vueTypes["default"].oneOfType([_vueTypes["default"].array, _vueTypes["default"].string]),
  // 数据
  data: _vueTypes["default"].object.def({}),
  // 图片是否启用osssts临时授权访问
  useOssSTSPolicy: _vueTypes["default"].oneOfType([_vueTypes["default"].string, _vueTypes["default"].bool]).def(false),
  // 启用了oss临时授权，就必须传入ossClient
  ossClient: _vueTypes["default"].object,
  // oss图片超时时间
  ossTimeout: _vueTypes["default"].number.def(5000)
};
exports.DetailProps = DetailProps;
var EASY_DETAIL_TYPE = {
  // 普通文字
  TEXT: 'text',
  // 字典协议
  DICT: 'dict',
  // 本地枚举值
  ENUM: 'enum',
  // 图片
  IMAGE: 'image'
};
exports.EASY_DETAIL_TYPE = EASY_DETAIL_TYPE;