"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _types = require("./types");

var _isPromise = _interopRequireDefault(require("is-promise"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/**
 * 字典描述显示
 */
var _default = {
  name: 'EDictText',
  props: _types.DictTextProps,
  data: function data() {
    return {
      // 显示文字
      caption: ''
    };
  },
  mounted: function mounted() {
    this._getDictCaption();
  },
  methods: {
    /**
     * 根据字典组id获取字典列表。此方法需要在Vue.use挂载组件的时候被覆盖
     */
    getDictList: function getDictList() {},

    /**
     * 获取显示的字典值
     * @private
     */
    _getDictCaption: function _getDictCaption() {
      var _this = this;

      var result = this.getDictList(this.$props.dictId);

      if ((0, _isPromise["default"])(result)) {
        result.then(function (res) {
          var dictObj = res.find(function (item) {
            return item.name === _this.$props.name;
          });
          _this.$data.caption = dictObj ? dictObj.caption : _this.$props.name;
        })["catch"](function () {
          _this.$data.caption = _this.$props.defaultValue;
        });
      } else {
        this.$data.caption = this.$props.defaultValue;
      }
    }
  },
  render: function render() {
    var h = arguments[0];
    var caption = this.$data.caption;
    return h("span", [caption]);
  }
};
exports["default"] = _default;